 Mailman/Archiver/Archiver.py        |   29 
 Mailman/Archiver/HyperArch.py       |   18 
 Mailman/Archiver/pipermail.py       |   14 
 Mailman/Bouncers/BouncerAPI.py      |   12 
 Mailman/Bouncers/Caiwireless.py     |    2 
 Mailman/Bouncers/DSN.py             |   12 
 Mailman/Bouncers/GroupWise.py       |    4 
 Mailman/Bouncers/Microsoft.py       |    2 
 Mailman/Bouncers/Netscape.py        |    2 
 Mailman/Bouncers/Postfix.py         |    4 
 Mailman/Bouncers/Qmail.py           |   18 
 Mailman/Bouncers/SMTP32.py          |    8 
 Mailman/Bouncers/SimpleMatch.py     |   58 
 Mailman/Bouncers/SimpleWarning.py   |   12 
 Mailman/Cgi/admin.py                |    5 
 Mailman/Cgi/admindb.py              |    2 
 Mailman/Cgi/confirm.py              |    2 
 Mailman/Cgi/edithtml.py             |    2 
 Mailman/Cgi/listinfo.py             |    2 
 Mailman/Cgi/options.py              |    2 
 Mailman/Cgi/private.py              |    6 
 Mailman/Cgi/rmlist.py               |    5 
 Mailman/Cgi/roster.py               |    2 
 Mailman/Cgi/subscribe.py            |    2 
 Mailman/Defaults.py.in              |   81 -
 Mailman/Deliverer.py                |    5 
 Mailman/Gui/Digest.py               |    3 
 Mailman/Gui/General.py              |    2 
 Mailman/Gui/Privacy.py              |    2 
 Mailman/Gui/Topics.py               |    5 
 Mailman/HTMLFormatter.py            |    3 
 Mailman/Handlers/Approve.py         |    7 
 Mailman/Handlers/Cleanse.py         |   11 
 Mailman/Handlers/CookHeaders.py     |   35 
 Mailman/Handlers/Decorate.py        |   17 
 Mailman/Handlers/Hold.py            |    3 
 Mailman/Handlers/SMTPDirect.py      |    2 
 Mailman/Handlers/Scrubber.py        |   28 
 Mailman/Handlers/SpamDetect.py      |   19 
 Mailman/Handlers/Tagger.py          |    7 
 Mailman/Handlers/ToArchive.py       |   13 
 Mailman/Handlers/ToDigest.py        |   17 
 Mailman/ListAdmin.py                |    4 
 Mailman/MTA/Manual.py               |    4 
 Mailman/MTA/Postfix.py              |  127 +
 Mailman/MTA/Utils.py                |   18 
 Mailman/MailList.py                 |   83 -
 Mailman/Message.py                  |    2 
 Mailman/Queue/ArchRunner.py         |    2 
 Mailman/Queue/BounceRunner.py       |   21 
 Mailman/Queue/NewsRunner.py         |    8 
 Mailman/SecurityManager.py          |    8 
 Mailman/Site.py                     |   78 -
 Mailman/Utils.py                    |   49 
 Mailman/Version.py                  |   10 
 Mailman/i18n.py                     |   15 
 Makefile.in                         |    2 
 NEWS                                |   15 
 README                              |   17 
 TODO                                |    2 
 bin/Makefile.in                     |    2 
 bin/cleanarch                       |    7 
 bin/list_lists                      |    7 
 bin/mailmanctl                      |    9 
 bin/newlist                         |   22 
 bin/qrunner                         |   16 
 bin/show_qfiles                     |   23 
 bin/update                          |    1 
 configure.in                        |   84 -
 contrib/README.mmdsr                |   64 
 contrib/mmdsr                       |  118 -
 messages/Makefile.in                |   17 
 messages/docstring.files            |    4 
 messages/ja/doc/Defaults.py.in      |   82 -
 messages/ja/doc/mailman-install.tex |    4 
 messages/mailman.pot                | 2527 ++++++------------------------------
 messages/marked.files               |    3 
 misc/Makefile.in                    |   21 
 misc/paths.py.in                    |   16 
 templates/Makefile.in               |   15 
 tests/test_bounces.py               |   44 
 81 files changed, 1228 insertions(+), 2808 deletions(-)

diff -pru mailman-cvs-HEAD/bin/cleanarch mailman-2.1.7.cg/bin/cleanarch
--- mailman-cvs-HEAD/bin/cleanarch	2006-01-22 21:34:46.000000000 +0100
+++ mailman-2.1.7.cg/bin/cleanarch	2005-08-27 03:40:16.000000000 +0200
@@ -1,6 +1,6 @@
 #! @PYTHON@
 
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2003 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -14,8 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Clean up an .mbox archive file.
 
@@ -60,7 +59,7 @@ cre = re.compile(mailbox.UnixMailbox._fr
 # From RFC 2822, a header field name must contain only characters from 33-126
 # inclusive, excluding colon.  I.e. from oct 41 to oct 176 less oct 072.  Must
 # use re.match() so that it's anchored at the beginning of the line.
-fre = re.compile(r'[\041-\071\073-\176]+')
+fre = re.compile(r'[\041-\071\073-\0176]+')
 
 
 
diff -pru mailman-cvs-HEAD/bin/list_lists mailman-2.1.7.cg/bin/list_lists
--- mailman-cvs-HEAD/bin/list_lists	2005-08-27 03:54:03.000000000 +0200
+++ mailman-2.1.7.cg/bin/list_lists	2006-02-22 10:28:36.000000000 +0100
@@ -108,13 +108,16 @@ def main():
     if not bare:
         print len(mlists), _('matching mailing lists found:')
 
-    format = '%%%ds - %%.%ds' % (longest, 77 - longest)
+    format = '%%%ds%%s - %%.%ds' % (longest, 77 - longest)
     for mlist in mlists:
         if bare:
             print mlist.internal_name()
         else:
             description = mlist.description or _('[no description available]')
-            print '   ', format % (mlist.real_name, description)
+            if '@' in mlist.internal_name():
+                print '   ', format % (mlist.real_name, '@', description)
+            else:
+                print '   ', format % (mlist.real_name, ' ', description)
 
 
 
diff -pru mailman-cvs-HEAD/bin/mailmanctl mailman-2.1.7.cg/bin/mailmanctl
--- mailman-cvs-HEAD/bin/mailmanctl	2006-02-05 05:45:31.000000000 +0100
+++ mailman-2.1.7.cg/bin/mailmanctl	2005-08-27 03:40:16.000000000 +0200
@@ -1,6 +1,6 @@
 #! @PYTHON@
 
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2004 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -14,8 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Primary start-up and shutdown script for Mailman's qrunner daemon.
 
@@ -419,8 +418,8 @@ def main():
         os.setsid()
         # Instead of cd'ing to root, cd to the Mailman installation home
         os.chdir(mm_cfg.PREFIX)
-        # Set our file mode creation umask
-        os.umask(007)
+        # Clear our file mode creation umask
+        os.umask(0)
         # I don't think we have any unneeded file descriptors.
         #
         # Now start all the qrunners.  This returns a dictionary where the
diff -pru mailman-cvs-HEAD/bin/newlist mailman-2.1.7.cg/bin/newlist
--- mailman-cvs-HEAD/bin/newlist	2005-08-28 07:41:46.000000000 +0200
+++ mailman-2.1.7.cg/bin/newlist	2006-03-10 12:52:10.000000000 +0100
@@ -73,6 +73,9 @@ where `mydom.ain' is the mail domain nam
 urlhost is not in the virtual host list, then mm_cfg.DEFAULT_EMAIL_HOST will
 be used for the email interface.
 
+NDIM XXX Ooops. How to keep this backward compatibility below? The
+vhost branch newlist is currently following a different model.
+
 For backward compatibility, you can also specify the domain to create your
 new list in by spelling the listname like so:
 
@@ -154,12 +157,23 @@ def main():
     else:
         listname = raw_input(_('Enter the name of the list: '))
     listname = listname.lower()
-
+    
     if '@' in listname:
         # note that --urlhost and --emailhost have precedence
-        listname, domain = listname.split('@', 1)
-        urlhost = urlhost or domain
-        emailhost = emailhost or mm_cfg.VIRTUAL_HOSTS.get(domain, domain)
+        firstname, domain = listname.split('@', 1)
+        urlhost = urlhost or ('lists.%s' % domain) # TODO: Not configurable yet
+        if not emailhost:
+            emailhost = domain
+        else:
+            usage(1, _('You cannot use an email host different from the domain part of the list name.'))
+        if not mm_cfg.VIRTUAL_HOSTS.has_key(urlhost):
+            _urlhost = repr(urlhost)
+            _emailhost = repr(emailhost)
+            usage(1, _('The Mailman config file lacks a line mapping urlhost to emailhost:\n  add_virtualhost(%(_urlhost)s,\n                  %(_emailhost)s)'))
+    else:
+        # Handle site wide lists (non-vhost lists, i.e. without '@' in their name)
+        # in the traditional manner.
+        pass
 
     urlhost = urlhost or mm_cfg.DEFAULT_URL_HOST
     host_name = emailhost or \
diff -pru mailman-cvs-HEAD/bin/qrunner mailman-2.1.7.cg/bin/qrunner
--- mailman-cvs-HEAD/bin/qrunner	2006-01-19 02:06:23.000000000 +0100
+++ mailman-2.1.7.cg/bin/qrunner	2005-08-27 03:40:16.000000000 +0200
@@ -1,6 +1,6 @@
 #! @PYTHON@
 
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -14,8 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Run one or more qrunners, once or repeatedly.
 
@@ -67,9 +66,6 @@ Options:
 
 runner is required unless -l or -h is given, and it must be one of the names
 displayed by the -l switch.
-
-Note also that this script should be started up from mailmanctl as a normal
-operation.  It is only useful for debugging if it is run separately.
 """
 
 import sys
@@ -88,6 +84,8 @@ COMMASPACE = ', '
 # Flag which says whether we're running under mailmanctl or not.
 AS_SUBPROC = 0
 
+LogStdErr('error', 'qrunner', manual_reprime=0)
+
 
 
 def usage(code, msg=''):
@@ -214,12 +212,6 @@ def main():
     if len(runners) == 0:
         usage(1, _('No runner name given.'))
 
-    # Before we startup qrunners, we redirect the stderr to mailman syslog.
-    # We assume !AS_SUBPROC is running for debugging purpose and don't
-    # log errors in mailman logs/error but keep printing to stderr.
-    if AS_SUBPROC:
-        LogStdErr('error', 'qrunner', manual_reprime=0, tee_to_real_stderr=0)
-
     # Fast track for one infinite runner
     if len(runners) == 1 and not once:
         qrunner = make_qrunner(*runners[0])
diff -pru mailman-cvs-HEAD/bin/show_qfiles mailman-2.1.7.cg/bin/show_qfiles
--- mailman-cvs-HEAD/bin/show_qfiles	2006-03-10 11:36:03.000000000 +0100
+++ mailman-2.1.7.cg/bin/show_qfiles	2003-09-22 04:29:50.000000000 +0200
@@ -1,21 +1,4 @@
 #! @PYTHON@
-#
-# Copyright (C) 2006 by the Free Software Foundation, Inc.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
 
 """Show the contents of one or more Mailman queue files.
 
@@ -81,11 +64,7 @@ def main():
         fp = open(filename)
         if filename.endswith(".pck"):
             msg = load(fp)
-            data = load(fp)
-            if data.get('_parsemsg'):
-                sys.stdout.write(msg)
-            else:
-                sys.stdout.write(msg.as_string())
+            sys.stdout.write(msg.as_string())
         else:
             sys.stdout.write(fp.read())
 
diff -pru mailman-cvs-HEAD/bin/update mailman-2.1.7.cg/bin/update
--- mailman-cvs-HEAD/bin/update	2005-08-28 07:41:46.000000000 +0200
+++ mailman-2.1.7.cg/bin/update	2006-03-06 12:12:27.000000000 +0100
@@ -344,6 +344,7 @@ script.
     #
     tmpl_dir = os.path.join(mm_cfg.PREFIX, "templates")
     list_dir = os.path.join(mm_cfg.PREFIX, "lists")
+    # NDIM XXX internal_name
     b4_tmpl_dir = os.path.join(tmpl_dir, mlist._internal_name)
     new_tmpl_dir = os.path.join(list_dir, mlist._internal_name)
     if os.path.exists(b4_tmpl_dir):
diff -pru mailman-cvs-HEAD/configure.in mailman-2.1.7.cg/configure.in
--- mailman-cvs-HEAD/configure.in	2005-12-06 05:31:56.000000000 +0100
+++ mailman-2.1.7.cg/configure.in	2005-08-27 03:40:15.000000000 +0200
@@ -15,7 +15,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 dnl Process this file with autoconf to produce a configure script.
-AC_REVISION($Revision: 2.46 $)
+AC_REVISION($Revision: 2.39.2.7 $)
 AC_PREREQ(2.0)
 AC_INIT(src/common.h)
 
@@ -273,7 +273,7 @@ rm -f conftest.out conftest.py])
 # Check for some other uid to use than `mailman'
 AC_MSG_CHECKING(for --with-username)
 AC_ARG_WITH(username, dnl
-[  --with-username      specify a user name other than "mailman"])
+[  --with-username      specify a user name other than \"mailman\"])
 
 if test -z "$with_username"
 then
@@ -303,7 +303,7 @@ AC_MSG_RESULT(okay)
 # Check for some other gid to use than `mailman'
 AC_MSG_CHECKING(for --with-groupname)
 AC_ARG_WITH(groupname, dnl
-[  --with-groupname     specify a group name other than "mailman"])
+[  --with-groupname     specify a group name other than \"mailman\"])
 
 if test -z "$with_groupname"
 then
@@ -507,57 +507,6 @@ fi
 AC_MSG_RESULT($URLHOST)
 rm -f conftest.out conftest.py
 
-# i18n --with-languages
-ALL_LINGUAS=`(cd ${srcdir}/messages && ls | grep '^..\(_..\)*$' | tr '\n' ' ')`
-AC_SUBST(LANGUAGES)
-AC_MSG_CHECKING(for --with-languages)
-AC_ARG_WITH(languages, dnl
-[  --with-languages     add i18n languages: specify "none" for English only.])
-if test -z "$with_languages"
-then
-      LANGUAGES="$ALL_LINGUAS"
-elif test "$with_languages" = "none"
-then
-      LANGUAGES=""
-else
-      LANGUAGES="$with_languages"
-fi
-AC_MSG_RESULT($with_languages)
-
-# check CJKCodecs
-AC_MSG_CHECKING(for CJK codecs)
-changequote(,)
-cat > conftest.py <<EOF
-langs = "$LANGUAGES".split()
-cset = {'ja': 'euc-jp', 'ko': 'euc-kr', 
-        'zh_CN': 'gb2312', 'zh_TW': 'big5'}
-s = 'Not required'
-for lang in cset.keys():
-    if lang in langs:
-        try:
-            s = unicode('OK', cset[lang]).encode('us-ascii')
-        except LookupError:
-            s = ''
-            break
-fp = open("conftest.out", "w")
-fp.write("%s\n" % s)
-fp.close()
-EOF
-changequote([, ])
-$PYTHON conftest.py
-cjkok=`cat conftest.out`
-rm -f conftest.out conftest.py
-if test -z "$cjkok"
-then
-    AC_MSG_ERROR([
-***** At least one of the CJK codecs missing!
-***** You have included ja, ko, or zh_* in --with-languages 
-***** but valid codecs are not installed. You should
-***** either install CJKCodecs from http://cjkpython.i18n.org/
-***** or use Python 2.4 in which CJK languages are supported.])
-fi
-AC_MSG_RESULT($cjkok)
-
 # Checks for libraries.
 AC_CHECK_FUNCS(strerror setregid syslog)
 if test $ac_cv_func_syslog = no; then
@@ -630,8 +579,6 @@ bin/version \
 bin/withlist \
 bin/b4b5-archfix \
 bin/rb-archfix \
-bin/templ2pot.py \
-bin/po2templ.py \
 contrib/check_perms_grsecurity.py \
 contrib/qmail-to-mailman.py \
 contrib/rotatelogs.py \
@@ -679,3 +626,28 @@ AC_OUTPUT([misc/paths.py Mailman/Default
 # Make sure all the build scripts are executable.
 chmod -R +x build
 
+# Test for the Chinese codecs.
+dnl AC_MSG_CHECKING(for Python Chinese Unicode codecs)
+dnl cat > conftest.py <<EOF
+dnl try:
+dnl   unicode("abc", "big5-tw")
+dnl   print "found"
+dnl except LookupError:
+dnl   print "not found"
+dnl EOF
+dnl chinese=`$PYTHON conftest.py 2>/dev/null`
+dnl rm -f conftest.py
+dnl AC_MSG_RESULT($chinese)
+dnl if test "x$chinese" != "xfound"
+dnl then
+dnl     AC_MSG_WARN([
+
+dnl ***** Python Unicode codecs for Chinese not found.
+dnl ***** Chinese emails generated by or manipulated in Mailman will not
+dnl ***** be sent in the correct encoding and may be unreadable.
+dnl ***** Please uncompress and install the Chinese codecs from:
+dnl ***** http://sourceforge.net/projects/python-codecs/
+dnl *****
+dnl ***** Note: Everything else will work just fine.
+dnl ])
+dnl fi
diff -pru mailman-cvs-HEAD/contrib/mmdsr mailman-2.1.7.cg/contrib/mmdsr
--- mailman-cvs-HEAD/contrib/mmdsr	2006-01-29 18:41:37.000000000 +0100
+++ mailman-2.1.7.cg/contrib/mmdsr	2005-12-25 04:21:56.000000000 +0100
@@ -112,43 +112,6 @@
 #		Adrian discovered that there was a log file format
 #		change between Mailman 2.1.5 and 2.1.6, which broke
 #		hourly statistics.
-#
-# 0.0.13	Update by Brad Knowles <brad@stop.mail-abuse.org>
-#		Updated on: Mon Dec 26 05:54:27 CET 2005
-#		Bugs found by Tom G. Christensen (tgc99):
-#		> ps output on solaris is full of whitespace but a further
-#		> echo get's rid of it.
-#		> The lines in the smtp log are sometimes broken up by a
-#		> newline (right before the msgid) which throws of the
-#		> summary. Piping it through sed first will rejoin the broken
-#		> lines.
-#		> Use $AWK instead of awk.
-#		Enhancements from Mark Sapiro:
-#		> The vette log summary lists posts held for moderation
-#		> individually under "Other Errors:". The following patch
-#		> (watch out for wrapped lines) summarizes them by list instead.
-#
-# 0.0.14	Update by Brad Knowles <brad@stop.mail-abuse.org>
-#		Updated on: Thu Dec 29 08:17:38 CET 2005
-#		Added code to check /usr/local/mailman/data for
-#		moderation hold queue
-#
-# 0.0.15	Update by Brad Knowles <brad@stop.mail-abuse.org>
-#		Updated on: Thu Jan 26 02:39:38 CET 2006
-#		Tweaked display of summary data in the "smtp-failure" log,
-#		and "other" category in the "vette" log, so as to reduce
-#		the spewage when things go wonky, mostly by removing
-#		unique-ifying data like message-id or sender address.
-#		Also tweaked moderation queue information, to tell us
-#		how many Python pickle files are in the data directory,
-#		as opposed to just doing a directory listing and skipping
-#		the files in the middle if there are too many -- now we
-#		know how many are being skipped.
-#
-# 0.0.16	Update by Brad Knowles <brad@stop.mail-abuse.org>
-#		Updated on: Sun Jan 29 11:45:58 CET 2006
-#		Mark found a couple of typos that I somehow let slip
-#		through.  Thanks!
 
 ###############################################################################
 # Set up locations of standard commands, directories, etc....
@@ -193,19 +156,9 @@ QUEUEDIR="/usr/local/mailman/qfiles"
 LOGDIR="/usr/local/mailman/logs"
 
 ###############################################################################
-# Mailman data directory
-###############################################################################
-DATADIR="/usr/local/mailman/data"
-
-###############################################################################
 # Maximum number of subdirectory entries to display in report
 ###############################################################################
-MAX_QUEUE_LINES=20
-
-###############################################################################
-# Maximum number of moderation queue pickle files to display in report
-###############################################################################
-MAX_DATA_LINES=100
+MAX_LINES=20
 
 ###############################################################################
 # Mailman Log files to check for errors.
@@ -229,8 +182,8 @@ SUBDIRS="archive bounces commands in new
 # Specify sender address for report.  Not used if recipient list is empty.
 ###############################################################################
 
-SENDER="INSERT.YOUR.SENDER.ADDRESS@HERE"
-RCPTS="INSERT.YOUR.RECIPIENTS.ADDRESSES@HERE"
+SENDER="put@your.address.here"
+RCPTS="put@the.address.of,your@recipients.here"
 
 ###############################################################################
 # If you run this program in cron at 23:59:00, you need to sleep sixty
@@ -250,8 +203,7 @@ SLEEPTIME=60
 #	there is an easier cross-platform way to do it, please let me know.
 ###############################################################################
 
-GRABUID=`$PS -o user -p $$ | $TAIL -1`
-MYUID=`echo $GRABUID`
+MYUID=`$PS -o user -p $$ | $TAIL -1`
 RUNAS="mailman"
 
 ###############################################################################
@@ -302,9 +254,9 @@ do
     $TOUCH $TMPLOG
     echo "Log file: $LOG" >> $TMP
     echo "==============================" >> $TMP
+    $GREP -si "^$DAY [0-9][0-9:]* $YEAR" $LOGDIR/$LOG >> $TMPLOG
 
     if [ -f "$LOGDIR/${LOG}" ] ; then
-    $SED -e :a -e '$!N;s/\n //;ta' -e 'P;D' $LOGDIR/$LOG | $GREP -si "^$DAY [0-9][0-9:]* $YEAR" >> $TMPLOG
 
 	if [ "${LOG}" = "post" ] ; then
 
@@ -312,7 +264,7 @@ do
 	    echo "Hourly Summary of Posts" >> $TMP
 	    echo "-----------------------" >> $TMP
 
-	    $SED -e 's/^[A-Z][a-z][a-z] *[0-9]* //' -e 's/:.*$//' $TMPLOG | $UNIQ -c | $SORT -n +1 | $AWK '{ printf( "%8d  %02d:00-%02d:59\n", $1, $2, $2 ) }' >> $TMP
+	    $SED -e 's/^[A-Z][a-z][a-z] *[0-9]* //' -e 's/:.*$//' $TMPLOG | $UNIQ -c | $SORT -n +1 | awk '{ printf( "%8d  %02d:00-%02d:59\n", $1, $2, $2 ) }' >> $TMP
 
 	    echo "" >> $TMP
 	    echo "Post Count by List" >> $TMP
@@ -343,7 +295,7 @@ do
 	    echo "" >> $TMP
 	    echo "Hourly Summary of Messages Sent" >> $TMP
 	    echo "-------------------------------" >> $TMP
-	    $SED -e 's/^[A-Z][a-z][a-z] *[0-9]* //' -e 's/:.* for / /' -e 's/ recips,.*$//' $TMPLOG | $AWK '{ val=int($1); sum[val]+=$2 } END { for (i=0; i<24; i++) { printf "%8d %02d:00-%02d:59\n", sum[i], i, i } }' >> $TMP
+	    $SED -e 's/^[A-Z][a-z][a-z] *[0-9]* //' -e 's/:.* for / /' -e 's/ recips,.*$//' $TMPLOG | awk '{ val=int($1); sum[val]+=$2 } END { for (i=0; i<24; i++) { printf "%8d %02d:00-%02d:59\n", sum[i], i, i } }' >> $TMP
 
 	else
 
@@ -464,18 +416,9 @@ do
 	    $GREP -i 'Posting to a moderated newsgroup' $TMPLOG | $AWK '{ print $6 }' | $SORT | $UNIQ -c | $SORT -nr >> $TMP
 
 	    echo "" >> $TMP
-	    echo "Post to moderated list (by list):" >> $TMP
-	    echo "------------------------------" >> $TMP
-	    $GREP -i 'Post to moderated list' $TMPLOG | $AWK '{ print $6 }' | $SORT | $UNIQ -c | $SORT -nr >> $TMP
-
-	    echo "" >> $TMP
 	    echo "Other Errors:" >> $TMP
 	    echo "------------------------------" >> $TMP
-	    $EGREP -vi '(Post by non-member|suspicious header|message approved|Discarded posting|bulk message discarded|junk message discarded|Message has implicit destination|Posting to a moderated newsgroup|Post to moderated list|Message discarded, msgid)' $TMPLOG | $SED -e 's/^.* ([0-9]*) //' -e 's/, message-id=<[^> ]*>:/:/' | $SORT | $UNIQ -c | $SORT -nr >> $TMP 
-
-	elif [ "${LOG}" = "smtp-failure" ] ; then
-
-	    $SED 's/^.* ([0-9]*) //' $TMPLOG | $SED 's/delivery to [^@ ]*@[^@ ]* failed with code/delivery failed with code/g' | $SORT | $UNIQ -c | $SORT -nr >> $TMP 
+	    $EGREP -vi '(Post by non-member|suspicious header|message approved|Discarded posting|bulk message discarded|junk message discarded|Message has implicit destination|Posting to a moderated newsgroup|Message discarded, msgid)' $TMPLOG | $SED 's/^.* ([0-9]*) //' | $SORT | $UNIQ -c | $SORT -nr >> $TMP 
 
 	else
 
@@ -503,7 +446,7 @@ do
     $RM -f $TMPLOG
     $TOUCH $TMPLOG
     $LS -la $DIR >> $TMPLOG
-    LINES=`$WC -l < $TMPLOG`
+    LINES=`wc -l < $TMPLOG`
     LINES=`expr $LINES - 3`
 
     echo "Subdirectory: $DIR" >> $TMP
@@ -511,12 +454,12 @@ do
     echo "Entries: $LINES" >> $TMP
     echo "------------------------------" >> $TMP
 
-    if [ $LINES -le $MAX_QUEUE_LINES ] ; then
+    if [ $LINES -le $MAX_LINES ] ; then
     	$CAT $TMPLOG >> $TMP
     else
     	$HEAD $TMPLOG >> $TMP
 	echo "" >> $TMP
-	echo "	More than $MAX_QUEUE_LINES total entries, skipping ..." >> $TMP
+	echo "	More than $MAX_LINES total entries, skipping ..." >> $TMP
 	echo "" >> $TMP
     	$TAIL $TMPLOG >> $TMP
     fi
@@ -524,45 +467,6 @@ do
 
 done
 
-echo "******************************" >> $TMP
-echo "Data Directory Contents" >> $TMP
-echo "	(Python pickle files only)" >> $TMP
-echo "******************************" >> $TMP
-
-cd $DATADIR
-
-$RM -f $TMPLOG
-$TOUCH $TMPLOG
-$LS -la | $GREP -i '\.pck$' >> $TMPLOG
-LINES=`$WC -l < $TMPLOG`
-
-echo "Python pickle files: $LINES" >> $TMP
-echo "==============================" >> $TMP
-echo "" >> $TMP
-
-if [ $LINES -le $MAX_DATA_LINES ] ; then
-    $CAT $TMPLOG >> $TMP
-else
-    $HEAD $TMPLOG >> $TMP
-    echo "" >> $TMP
-    echo "	More than $MAX_DATA_LINES total entries, skipping ..." >> $TMP
-    echo "" >> $TMP
-    $TAIL $TMPLOG >> $TMP
-fi
-echo "" >> $TMP
-
-echo "******************************" >> $TMP
-echo "Moderation Queue Summary" >> $TMP
-echo "******************************" >> $TMP
-echo "" >> $TMP
-
-$AWK '{ print $NF }' $TMPLOG | $GREP -i '^heldmsg-' | $SED -e 's/^heldmsg-//' -e 's/-[0-9]*\.pck$//' | $SORT | $UNIQ -c | $SORT -nr >> $TMP
-echo "" >> $TMP
-
-###############################################################################
-# Okay, we're done with all the code stuff, now handle the output
-###############################################################################
-
 if [ "${RCPTS}x" != "x" ] ; then
     $SENDMAIL -t -f$SENDER < $TMP
 else
diff -pru mailman-cvs-HEAD/contrib/README.mmdsr mailman-2.1.7.cg/contrib/README.mmdsr
--- mailman-cvs-HEAD/contrib/README.mmdsr	2006-01-29 18:41:37.000000000 +0100
+++ mailman-2.1.7.cg/contrib/README.mmdsr	2005-12-30 19:58:15.000000000 +0100
@@ -5,41 +5,31 @@ for mailman.  It was initially posted at
 <http://sourceforge.net/tracker/index.php?func=detail&aid=1123383&group_id=103&atid=300103>
 which see for possible patches and other enhancements.
 
-Here goes the original mmdsr.readme by Brad ...
+It is intended that there will be a 'cleaner', more complete readme file in
+the future.  In the interim, here are Brad's original comments.
 
-========================================================================
-This is a basic Bourne shell script that I quickly hacked together for
-my own purposes, designed to be fired off at 23:59 every night, going
-through a variety of Mailman log files looking for entries specific
-to that date, summarizing the activities, and indicating problems or
-certain types of activity that might be of interest to someone trying
-to administer the server.
-
-It also does an "ls -la" of /usr/local/mailman/qfiles/*, so that you
-can see what is in the queue at the time of the execution of the script.
-
-This daily report will get e-mailed to the admin, or posted to a "reports"
-mailing list, where they can be archived and kept for future reference.
-If you don't define an address where the output e-mail should be sent,
-it will instead be printed to the standard output (thus allowing you to
-do something else with it).
-
-
-Once I'd gone through a few revisions of my own on this tool, I
-thought that I would release the code to the public and get comments
-and suggestions from others in the Mailman community.  This program is
-currently being used actively on the mail servers for python.org (where
-the mailman-users and other Mailman-related mailing lists are hosted),
-as well as many others.
-
-Note that this script needs to be configured once to know where standard
-commands are located, where log files are kept, etc... (see the top
-500 lines or so of the script), but after that you don't need to feed
-it any input, or capture the output to be sent anywhere.  This script
-takes care of all of that.  All you should need to do is to call this
-script from a cron job at 23:59 (local time) every night.
-
-
-When looking at this script, perhaps during configuration, please keep
-in mind that it is heavily commented at the top, and everything should
-hopefully be self-evident.
+I quickly whacked together a Daily Status Report script for Mailman (using
+Bourne shell, not Python ;), and thought that other folks might be interested
+in seeing it.
+
+The basic concept is a program that gets fired off at 23:59 every night, and
+goes through a variety of log files looking for entries specific to that date,
+and indicating problems or certain types of activity that might be of interest
+to someone trying to administer the server.  It also does an "ls -la" of
+/usr/local/mailman/qfiles/*, so that you can see what is in the queue at the
+time of the running of the script.
+
+My concept was that this daily report would get e-mailed to the admin, or
+posted to a "reports" mailing list, where they could be archived and kept for
+future reference.
+
+The script does not (yet) do any statistics calculations, although it should
+be relatively easy to hack together some basic stats using awk, sort, etc....
+
+Anyway, I thought I'd share it and let folks take a look at it, and if anyone
+has any recommended improvements, we can incorporate those and share them back
+out with everyone.
+
+The code is written under a BSD-style license, so if you don't want to
+contribute any changes back to me, that's okay. Of course, I would prefer that
+you did, but I leave the choice up to you.
